
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Controller 里面就只应该存放这些不能复用的代码（转） / iVAN</title>

    <meta name="description" content="Controller 里面就只应该存放这些不能复用的代码（转） MVC 的历史 MVC,全称是 Model View Controller,是模型 (model)-视图 (view)-控制器 (controller) 的缩写.它表示的是一种常见的客户端软件开发框架. MVC 的概念最早出现在二十世纪八十年代的施乐帕克实验室中(对,就是那个发明图形用户界面和鼠标的实验室),当时施乐帕克为 Smalltalk 发明了这种软件设计模式. 现在,MVC 已经成为主流的客户端编程框架,在 iOS 开发中,系统为我们实现好了公共的视图类:UIView,和控制器类:UIV">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Controller 里面就只应该存放这些不能复用的代码（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>　　MVC 的历史</h2>
<p>　　MVC，全称是 Model View Controller，是模型 (model)－视图 (view)－控制器 (controller) 的缩写。它表示的是一种常见的客户端软件开发框架。</p>
<p>　　MVC 的概念最早出现在二十世纪八十年代的施乐帕克实验室中（对，就是那个发明图形用户界面和鼠标的实验室），当时施乐帕克为 Smalltalk 发明了这种软件设计模式。</p>
<p>　　现在，MVC 已经成为主流的客户端编程框架，在 iOS 开发中，系统为我们实现好了公共的视图类：UIView，和控制器类：UIViewController。大多数时候，我们都需要继承这些类来实现我们的程序逻辑，因此，我们几乎逃避不开 MVC 这种设计模式。</p>
<p>　　但是，几十年过去了，我们对于 MVC 这种设计模式真的用得好吗？其实不是的，MVC 这种分层方式虽然清楚，但是如果使用不当，很可能让大量代码都集中在 Controller 之中，让 MVC 模式变成了 Massive View Controller 模式。</p>
<h2>　　Controller 的臃肿问题何解？</h2>
<p>　　很多人试图解决 MVC 这种架构下 Controller 比较臃肿的问题。我还记得半年前 InfoQ 搞了一次<a href="http://www.infoq.com/cn/news/2015/04/symposium-web-mvc" rel="external nofollow noreferrer">移动座谈会</a>，当时 <a href="https://github.com/gavinkwoe/BeeFramework" rel="external nofollow noreferrer">BeeFramework</a> 和 <a href="https://github.com/hackers-painters/samurai-native" rel="external nofollow noreferrer">Samurai-Native</a> 的作者 <a href="http://weibo.com/gavinkwoe" rel="external nofollow noreferrer">老郭</a> 问了我一句话：「什么样的内容才应该放到 Controller 中？」。但是当时因为时间不够，我没能展开我的观点，这次正好在这里好好谈谈我对于这个问题的想法。</p>
<p>　　我们来看看 MVC 这种架构的特点。其实设计模式很多时候是为了 <code>Don't repeat yourself</code> 原则来做的，该原则要求能够复用的代码要尽量复用，来保证重用。在 MVC 这种设计模式中，我们发现 View 和 Model 都是符合这种原则的。</p>
<p>　　对于 View 来说，你如果抽象得好，那么一个 App 的动画效果可以很方便地移植到别的 App 上，而 Github 上也有很多 UI 控件，这些控件都是在 View 层做了很好的封装设计，使得它能够方便地开源给大家复用。</p>
<p>　　对于 Model 来说，它其实是用来存储业务的数据的，如果做得好，它也可以方便地复用。比如我当时在做有道云笔记 iPad 版的时候，我们就直接和 iOS 版复用了所有的 Model 层的代码。在创业做猿题库客户端时，iOS 和 iPad 版的 Model 层代码再次被复用上了。当然，因为和业务本身的数据意义相关，Model 层的复用大多数是在一个产品内部，不太可能像 View 层那样开源给社区。</p>
<p>　　说完 View 和 Model 了，那我们想想 Controller，Controller 有多少可以复用的？我们写完了一个 Controller 之后，可以很方便地复用它吗？结论是：非常难复用。在某些场景下，我们可能可以用 <code>addSubViewController</code> 之类的方式复用 Controller，但它的复用场景还是非常非常少的。</p>
<p>　　如果我们能够意识到 Controller 里面的代码不便于复用，我们就能知道什么代码应该写在 Controller 里面了，那就是那些不能复用的代码。在我看来，Controller 里面就只应该存放这些不能复用的代码，这些代码包括：</p>
<ul>
<li>在初始化时，构造相应的 View 和 Model。</li>
<li>监听 Model 层的事件，将 Model 层的数据传递到 View 层。</li>
<li>监听 View 层的事件，并且将 View 层的事件转发到 Model 层。</li>
</ul>
<p>　　如果 Controller 只有以上的这些代码，那么它的逻辑将非常简单，而且也会非常短。</p>
<p>　　但是，我们却很难做到这一点，因为还是有很多逻辑我们不知道写在哪里，于是就都写到了 Controller 中了，那我们接下来就看看其它逻辑应该写在哪里。</p>
<h2>　　如何对 ViewController 瘦身？</h2>
<p>　　<a href="https://www.objc.io/" rel="external nofollow noreferrer">objc.io</a> 是一个非常有名的 iOS 开发博客，它上面的第一课 <a href="https://www.objc.io/issues/1-view-controllers/lighter-view-controllers/" rel="external nofollow noreferrer">《Lighter View Controllers》</a> 上就讲了很多这样的技巧，我们先总结一下它里面的观点：</p>
<ul>
<li>将 UITableView 的 Data Source 分离到另外一个类中。</li>
<li>将数据获取和转换的逻辑分别到另外一个类中。</li>
<li>将拼装控件的逻辑，分离到另外一个类中。</li>
</ul>
<p>　　你想明白了吗？其实 MVC 虽然只有三层，但是它并没有限制你只能有三层。所以，我们可以将 Controller 里面过于臃肿的逻辑抽取出来，形成新的可复用模块或架构层次。</p>
<p>　　我个人对于逻辑的抽取，有以下总结。</p>
<h3>　　将网络请求抽象到单独的类中</h3>
<p>　　新手写代码，直接就在 Controller 里面用 AFNetworking 发一个请求，请求的完数据直接就传递给 View。入门一些的同学，知道把这些请求代码移到另外一个静态类里面。但是我觉得还不够，所以我建议将每一个网络请求直接封装成类。</p>
<p>　　把每一个网络请求封装成对象其实是使用了设计模式中的 Command 模式，它有以下好处：</p>
<ul>
<li>将网络请求与具体的第三方库依赖隔离，方便以后更换底层的网络库。实际上我们公司的 iOS 客户端最初是基于 <a href="http://allseeing-i.com/ASIHTTPRequest/" rel="external nofollow noreferrer">ASIHttpRequest</a> 的，我们只花了两天，就很轻松地切换到了 <a href="https://github.com/AFNetworking/AFNetworking" rel="external nofollow noreferrer">AFNetworking</a>。</li>
<li>方便在基类中处理公共逻辑，例如猿题库的数据版本号信息就统一在基类中处理。</li>
<li>方便在基类中处理缓存逻辑，以及其它一些公共逻辑。</li>
<li>方便做对象的持久化。</li>
</ul>
<p>　　大家如果感兴趣，可以看我们公司开源的 iOS 网络库：<a href="https://github.com/yuantiku/YTKNetwork" rel="external nofollow noreferrer">YTKNetwork</a>。它在这种思考的指导下，不但将 Controller 中的代码瘦身，而且进一步演化和加强，现在它还支持诸如复杂网络请求管理，断点续传，插件机制，JSON 合法性检查等功能。</p>
<p>　　这部分代码从 Controller 中剥离出来后，不但简化了 Controller 中的逻辑，也达到了网络层的代码复用的效果。</p>
<h3>　　将界面的拼装抽象到专门的类中</h3>
<p>　　新手写代码，喜欢在 Controller 中把一个个 UILabel ，UIButton，UITextField 往 <code>self.view</code> 上用 <code>addSubView</code> 方法放。我建议大家可以用两种办法把这些代码从 Controller 中剥离。</p>
<p>　　方法一：构造专门的 UIView 的子类，来负责这些控件的拼装。这是最彻底和优雅的方式，不过稍微麻烦一些的是，你需要把这些控件的事件回调先接管，再都一一暴露回 Controller。</p>
<p>　　方法二：用一个静态的 Util 类，帮助你做 UIView 的拼装工作。这种方式稍微做得不太彻底，但是比较简单。</p>
<p>　　对于一些能复用的 UI 控件，我建议用方法一。如果项目工程比较复杂，我也建议用方法一。如果项目太紧，另外相关项目的代码量也不多，可以尝试方法二。</p>
<h3>　　构造 ViewModel</h3>
<p>　　谁说 MVC 就不能用 ViewModel 的？MVVM 的优点我们一样可以借鉴。具体做法就是将 ViewController 给 View 传递数据这个过程，抽象成构造 ViewModel 的过程。</p>
<p>　　这样抽象之后，View 只接受 ViewModel，而 Controller 只需要传递 ViewModel 这么一行代码。而另外构造 ViewModel 的过程，我们就可以移动到另外的类中了。</p>
<p>　　在具体实践中，我建议大家专门创建构造 ViewModel 工厂类，参见 <a href="http://baike.baidu.com/view/1306799.htm" rel="external nofollow noreferrer">工厂模式</a>。另外，也可以专门将数据存取都抽将到一个 Service 层，由这层来提供 ViewModel 的获取。</p>
<h3>　　专门构造存储类</h3>
<p>　　刚刚说到 ViewModel 的构造可以抽奖到一个 Service 层。与此相应的，数据的存储也应该由专门的对象来做。在小猿搜题项目中，我们由一个叫 UserAgent 的类，专门来处理本地数据的存取。</p>
<p>　　数据存取放在专门的类中，就可以针对存取做额外的事情了。比如：</p>
<ul>
<li>对一些热点数据增加缓存</li>
<li>处理数据迁移相关的逻辑</li>
</ul>
<p>　　如果要做得更细，可以把存储引擎再抽象出一层。这样你就可以方便地切换存储的底层，例如从 sqlite 切换到 key-value 的存储引擎等。</p>
<h3>　　小结</h3>
<p>　　通过代码的抽取，我们可以将原本的 MVC 设计模式中的 ViewController 进一步拆分，构造出网络请求层、ViewModel 层、Service 层、Storage 层等其它类，来配合 Controller 工作，从而使 Controller 更加简单，我们的 App 更容易维护。</p>
<p>　　另外，不知道大家注意到没，其实 Controller 层是非常难于测试的，如果我们能够将 Controller 瘦身，就可以更方便地写 Unit Test 来测试各种与界面的无关的逻辑。移动端自动化测试框架都不太成熟，但是将 Controller 的代码抽取出来，是有助于我们做测试工作的。</p>
<p>　　希望本文能帮助大家掌握正确使用 MVC 的姿势，在下一节里，我将分享一下我对 MVVM 的看法。</p>
<h1>　　被神化的 MVVM</h1>
<h2>　　MVVM 的历史</h2>
<p>　　<a href="https://en.wikipedia.org/wiki/Model_View_ViewModel" rel="external nofollow noreferrer">MVVM</a> 是 Model-View-ViewModel 的简写。</p>
<p>　　相对于 MVC 的历史来说，MVVM 是一个相当新的架构，MVVM 最早于 2005 年被微软的 WPF 和 Silverlight 的架构师 John Gossman 提出，并且应用在微软的软件开发中。当时 MVC 已经被提出了 20 多年了，可见两者出现的年代差别有多大。</p>
<p>　　MVVM 在使用当中，通常还会利用双向绑定技术，使得 Model 变化时，ViewModel 会自动更新，而 ViewModel 变化时，View 也会自动变化。所以，MVVM 模式有些时候又被称作：<a href="https://en.wikipedia.org/wiki/Model_View_ViewModel" rel="external nofollow noreferrer">model-view-binder</a> 模式。</p>
<p>　　具体在 iOS 中，可以使用 KVO 或 Notification 技术达到这种效果。</p>
<h2>　　MVVM 的神化</h2>
<p>　　在使用中，我发现大家对于 MVVM 以及 MVVM 衍生出来的框架（比如 <a href="https://github.com/ReactiveCocoa/ReactiveCocoa" rel="external nofollow noreferrer">ReactiveCocoa</a>）有一种「敬畏」感。这种「敬畏」感某种程度上就像对神一样，这主要表现在我没有听到大家对于 MVVM 的任何批评。</p>
<p>　　我感觉原因首先是 MVVM 并没有很大程度上普及，大家对于新技术一般都不熟，进而不敢妄加评论。另外，ReactiveCocoa 本身上手的复杂性，也让很多人感觉到这种技术很高深难懂，进而加重了大家对它的「敬畏」。</p>
<h2>　　MVVM 的作用和问题</h2>
<p>　　MVVM 在实际使用中，确实能够使得 Model 层和 View 层解耦，但是如果你需要实现 MVVM 中的双向绑定的话，那么通常就需要引入更多复杂的框架来实现了。</p>
<p>　　对此，MVVM 的作者 John Gossman 的 <a href="http://blogs.msdn.com/b/johngossman/archive/2006/03/04/543695.aspx" rel="external nofollow noreferrer">批评</a> 应该是最为中肯的。John Gossman 对 MVVM 的批评主要有两点：</p>
<p>　　第一点：数据绑定使得 Bug 很难被调试。你看到界面异常了，有可能是你 View 的代码有 Bug，也可能是 Model 的代码有问题。数据绑定使得一个位置的 Bug 被快速传递到别的位置，要定位原始出问题的地方就变得不那么容易了。</p>
<p>　　第二点：对于过大的项目，数据绑定需要花费更多的内存。</p>
<p>　　某种意义上来说，我认为就是数据绑定使得 MVVM 变得复杂和难用了。但是，这个缺点同时也被很多人认为是优点。</p>
<h2>　　ReactiveCocoa</h2>
<p>　　函数式编程（Functional Programming）和响应式编程（React Programming）也是当前很火的两个概念，它们的结合可以很方便地实现数据的绑定。于是，在 iOS 编程中，ReactiveCocoa 横空出世了，它的概念都非常 新，包括：</p>
<ul>
<li>函数式编程（Functional Programming），函数也变成一等公民了，可以拥有和对象同样的功能，例如当成参数传递，当作返回值等。看看 Swift 语言带来的众多函数式编程的特性，就你知道这多 Cool 了。</li>
<li>响应式编程（React Programming），原来我们基于事件（Event）的处理方式都弱了，现在是基于输入（在 ReactiveCocoa 里叫 Signal）的处理方式。输入还可以通过函数式编程进行各种 Combine 或 Filter，尽显各种灵活的处理。</li>
<li>无状态（Stateless），状态是函数的魔鬼，无状态使得函数能更好地测试。</li>
<li>不可修改（Immutable），数据都是不可修改的，使得软件逻辑简单，也可以更好地测试。</li>
</ul>
<p>　　哇，所有这些都太 Cool 了。当我看到的时候，我都鸡冻了！</p>
<h2>　　我们应该客观评价 MVVM 和 ReactiveCocoa</h2>
<p>　　但是但是，我突然想到，我好象只需要一个 ViewModel 而已，我完全可以简单地做一个 ViewModel 的工厂类或 Service 类就可以了，为什么要引入这么多框架？现有的 MVC 真的有那么大的问题吗？</p>
<p>　　直到现在，ReactiveCocoa 在国内外还都是在小众领域，没有被大量接受成为主流的编程框架。不只是在 iOS 语言，在别的语言中，例如 Java 中的 RxJava 也同样没有成为主流。</p>
<p>　　我在这里，不是想说 ReactiveCocoa 不好，也不是想说 MVVM 不好，而是想让大家都能够有一个客观的认识。ReactiveCocoa 和 MVVM 不应该被神化，它是一种新颖的编程框架，能够解决旧有编程框架的一些问题，但是也会带来一些新问题，仅此而已。如果不能使好的驾驭 ReactiveCocoa，同样会造成 Controller 代码过于复杂，代码逻辑不易维护的问题。</p>
<h2>　　总结</h2>
<p>　　有一些人总是追赶着技术，有什么新技术不管三七二十一立马就用，结果被各种坑。</p>
<p>　　又有一些人，总是担心新技术带来的技术风险，不愿意学习。结果现在还有人在用 MRC 手动管理引用计数。</p>
<p>　　而我想说，我们需要保持的是一个拥抱变化的心，以及理性分析的态度。在新技术的面前，不盲从，也不守旧，一切的决策都应该建立在认真分析的基础上，这样才能应对技术的变化。</p>
<p>http://kb.cnblogs.com/page/532236/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:17:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/ios/" title="ios">ios</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b/" title="编程">编程</a>, <a href="https://www.iamivan.net/tag/view/" title="view">view</a>, <a href="https://www.iamivan.net/tag/mvc/" title="mvc">mvc</a>, <a href="https://www.iamivan.net/tag/mvvm/" title="mvvm">mvvm</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Controller 里面就只应该存放这些不能复用的代码（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkG49Ep.html" rel="bookmark">PHP实现只在IE浏览器显示广告简单代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 HP实现只在IE浏览器显示广告简单代码,看下边的代码就知道了,真的很简单,这里使用了PHP的IF语句,并且使用了short_tags,服务器必须支持才可以哦. &lt;? if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false): ?&gt;  &lt;!-- 在此处插入(广告)代码 --&gt;  &lt;? endif; ?&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7r2vz.html" rel="bookmark">datagridview-Datagridview 不能插入多行，每次只插入一行，请帮忙分析代码问题所在，谢谢。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Datagridview 不能插入多行,每次只插入一行,请帮忙分析代码问题所在,谢谢. Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click Dim mycn As New SqlClient.SqlConnection Dim mycom As New SqlClient.SqlCommand mycn.Connection			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOXLEQb.html" rel="bookmark">通过ASP禁止指定IP和只允许指定IP访问网站的代码&lowbar;应用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.禁止指定IP防问网站,并执行相应操作: 复制代码 代码如下: &lt;% Dim IP,IPString,VisitIP '设置IP地址,用&quot;|&quot;隔开 IPString=&quot;|192.168.0.42|192.168.0.43|&quot; '获取IP地址 IP = Request.ServerVariables(&quot;HTTP_X_FORWARDED_FOR&quot;) If IP = &quot;&quot; Then IP = Request.ServerVa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4vmYM.html" rel="bookmark">通过ASP禁止指定IP和只允许指定IP访问网站的代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.禁止指定IP防问网站,并执行相应操作: 复制代码 代码如下: &lt;% Dim IP,IPString,VisitIP '设置IP地址,用&quot;|&quot;隔开 IPString=&quot;|192.168.0.42|192.168.0.43|&quot; '获取IP地址 IP = Request.ServerVariables(&quot;HTTP_X_FORWARDED_FOR&quot;) If IP = &quot;&quot; Then IP = Request.ServerVa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7wqO4z.html" rel="bookmark">js cookies 常见网页木马挂马代码 24小时只加载一次&lowbar;广告代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: &lt;div style='display:none'&gt; &lt;script type=&quot;text/javascript&quot;&gt; function goad(){ var Then = new Date() Then.setTime(Then.getTime() + 2*60*60*1000) var cookieString = new String(document.cookie) var cookieHeader = &quot;Cookier1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVG3xmb.html" rel="bookmark">弹出广告特效代码&lpar;一个IP只弹出一次&rpar;&lowbar;广告代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;script&gt; var cookieString = new String(document.cookie) var cookieHeader = 'happy_pop=' //更换happy_pop为任意名称 var beginPosition = cookieString.indexOf(cookieHeader) if (beginPosition &lt;0){ window.open('2.html','','top=0,left=0,width=787,height=480,to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5REnDz.html" rel="bookmark">android-Android 使用intent录音，为什么无法重新指定录制文件存放位置？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android 使用intent录音,为什么无法重新指定录制文件存放位置? 1.使用intent存放录制的音频,录音文件只存放在默认文件夹下 2.重新制定位置存放音频文件 解决方案 Android 使用intent录音,为什么无法重新指定录制文件存放位 EX07_11.java Java代码 收藏代码 package irdc.ex07_11; import java.io.File; import java.io.IOException; import java.util.Array			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLYykAz.html" rel="bookmark">php mvc中controller类实例教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 代码如下 复制代码 $route-&gt;run(); /**         * 执行相应的 MCA         *         */        private function run ()        {            $filePath = APPLICATION_PATH.'/controller/'.$this-&gt;_moudle.'/'.$this-&gt;_conttoller.'.inc.php';            $isNo = 0;         			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBPXgOp.html" rel="bookmark">&period;NET&sol;ASP&period;NET MVC Controller 控制器（深入解析控制器运行原理）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阅读目录: 1.开篇介绍 2.ASP.NETMVC Controller 控制器的入口(Controller的执行流程) 3.ASP.NETMVC Controller 控制器的入口(Controller的继承体系) 4.ASP.NETMVC IController Factory 控制器工厂(Controller的创建) 1]开篇介绍 经过前一篇文章.NET/ASP.NET Routing路由(深入解析路由系统架构原理) 的讲解,我们对ASP.NETRouting路由系统的整个运行机制有了一个			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpna6KM.html" rel="bookmark" class="title">针对 &period;NET 框架的安全编码指南</a>
					<div>
						安全|编码 摘要:公共语言运行库和 Microsoft .NET 框架对所有托管代码应用程序强制实施基于证据的安全性.大多数代码很少需要或完全不需要为安全性进行显式编码.本文简要描述了安全系统,讨论了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGxq6b.html" rel="bookmark" class="title">vb&period;net的Boolean数据类型</a>
					<div>
						Boolean型数据,也称布尔型.如果变量的值只是&quot;true/false&quot;.&quot;yes/no&quot;.&quot;on/off&quot;等逻辑值信息,可将其声明为Bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2r2Bp.html" rel="bookmark" class="title">基本教程篇--第六、七节</a>
					<div>
						HorizontalBarSampleDemo.cs和StackedBarSampleDemo.cs介绍 第六.七节HorizontalBarSampleDemo.cs和StackedBarSampl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNELONb.html" rel="bookmark" class="title">ASP&period;NET 2&period;0应用中定制安全凭证之理论篇</a>
					<div>
						阅读提要 在缺省状况下,你只能使用Visual Studio 2005的一个本机实例来 管理与ASP.NET 2.0一同发行的SQL Server数据库中的安全凭证.本文将向你展 示怎样用一个Web服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBRKYz.html" rel="bookmark" class="title">git命令添加 修改 删除 冲突解决办法</a>
					<div>
						  如果对git命令行不熟悉的话,用git图形界面工具,就比较合适了.建议使用tortoisegit这样的工具,命令行从学习到灵活掌握的时间成本比较高的. 1,添加 # git clone git@1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZdYDz.html" rel="bookmark" class="title">window系统打开任务管理器快捷键汇总</a>
					<div>
						  大家在使用电脑的过程中特别是程序卡死的时候需要经常打开任务管理器,那么打开任务管理器快捷键是什么呢? 一.Ctrl + Shift + ESC 组合键Ctrl + Shift + ESC无疑是xp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGaX7p.html" rel="bookmark" class="title">Win8手势功能禁用图解</a>
					<div>
						  禁用Windows 8系统的手势功能,只使用触控板点击和移动功能. 只需在控制面板---鼠标---ThinkPad中取消勾选&quot;启用手势&quot;.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW1Pmb.html" rel="bookmark" class="title">Windows基础排查之一 - 激活</a>
					<div>
						前言 想必大家还记得,若干年前还在用Windows XP时候,为了折腾操作系统,不少人应该都尝试去网上找寻过各种密钥,由于针对不同激活方式有不同的安装镜像,当时找到方便使用的多是VOL密钥以及与之相匹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL28nb.html" rel="bookmark" class="title">database-出现错误：SQLiteException&colon; no such table&colon; tabella &lpar;code1&rpar;</a>
					<div>
						问题描述 出现错误:SQLiteException: no such table: tabella (code1) 在访问数据库的时候, LogCat应用中出现错误: SQLiteException: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG90op.html" rel="bookmark" class="title">《Cisco BGP-4 命令与配置手册》&mdash;&mdash;1-1 aggregate-address address mask</a>
					<div>
						1-1 aggregate-address address mask Cisco BGP-4 命令与配置手册 语法描述: address:聚合路由的IP地址. mask:聚合路由的掩码. 用途:在BG ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YEA4M.html" rel="bookmark" class="title">网络通信-计算机网络技术概念方面的问题，求帮助</a>
					<div>
						问题描述 计算机网络技术概念方面的问题,求帮助 Internet 采用何种路由策略实现路由选择?路由器是怎样获取和维护路由表信息的? 解决方案 IP协议是一个大的协议栈,准确的说是TCP/IP协议栈. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWA6vp.html" rel="bookmark" class="title">360综合搜索vs百度大战 冷眼做看客继续支持Google</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 前言 这几天互联网最火的话题就是3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKxOrz.html" rel="bookmark" class="title">objective c-使用NSUInteger遇到的问题</a>
					<div>
						问题描述 使用NSUInteger遇到的问题 大家好,初次见面,多多关照 问题是这样的,我想用变量代替数字: NSUInteger *hoeveelChars = [eersteDertigTek l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7Y3LM.html" rel="bookmark" class="title">八皇后算法问题</a>
					<div>
						问题描述 问题是下面算法,为什么得不到真确结果?publicclassTest{publicstaticintn=8;//棋盘行列数publicstaticintcount=0;//皇后解法个数pub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94Ajvb.html" rel="bookmark" class="title">如何得到汇编代码的二进制码</a>
					<div>
						问题描述 如何得到汇编代码的二进制码 movl $0x51ade980,%eax movl %eax,0x804b1cc pushl $0x80490dc ret 有这样一段汇编码,请问要怎么将它们表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRm13b.html" rel="bookmark" class="title">&amp;amp&semi;amp&semi;&num;9733&semi;如何解释特修斯之船问题？</a>
					<div>
						如何解释特修斯之船问题?----来自知乎网友 一艘在海上航行了几百年的船,被不间断地维修和替换部件.只要一块木板腐烂了,它就会被替换掉,以此类推,直到所有的功能部件都不是最开始的那些了.问题是,最终产 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKXV5b.html" rel="bookmark" class="title">HBase源码：HMaster启动过程</a>
					<div>
						版本:HBase 0.94.15-cdh4.7.0 调试HMaster 说明: 这部分参考和使用了https://github.com/codefollower/HBase-Research上的代码( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rARkz.html" rel="bookmark" class="title">除了裸眼3D，亚马逊手机还会引入全新的手势交互</a>
					<div>
						摘要: 亚马逊的这款手机有些让人期待了. 不久前有消息称亚马逊会在今年六月发布一款手机,搭配4个前置摄像头和视网膜追踪技术,可以实时定位用户的眼球位置,无需需借助3D眼镜等任何 亚马逊的这款手机有些让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL5Vmp.html" rel="bookmark" class="title">hibernate未初始化</a>
					<div>
						问题描述 package com.jady.test;import java.util.HashSet;import java.util.Set;import org.hibernate.Hibern ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB66ZM.html" rel="bookmark" class="title">互联网金融，对于大部分人而言是个比较陌生的名词</a>
					<div>
						互联网金融,对于大部分人而言是个比较陌生的名词.不过随着余额宝的不断发展壮大,市场对于互联网金融开始有了初步的了解,而伴随着国内首家互联网保险公司的横空出世,互联网金融仿佛在一夜春风之后,成为大家谈论 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL3Pnp.html" rel="bookmark" class="title">2011年度十款最佳新闻媒体应用 社会化是未来</a>
					<div>
						2011年即将过去,在这一年里,不仅爆发了很多新闻事件,而且还涌现了很多优质的新媒体应用. 1.Bambuser Bambuser是一款利用手机和网络摄像头进行实时分享的工具(腾讯科技配图) Bamb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZJO3p.html" rel="bookmark" class="title">豆瓣刚刚推出金羊毛计划</a>
					<div>
						摘要: 音乐App挣钱一直是老大难的命题,不过这个行业依然持续在探索,豆瓣也是其中之一.针对豆瓣独立音乐人这个App,豆瓣刚刚推出了金羊毛计划,一个以播放量为标准向有独立版权的音 音乐App挣钱一直是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqDR2p.html" rel="bookmark" class="title">微信之父张小龙：怎样做简单的产品经理？三</a>
					<div>
						群体用户与个体用户 凯文·凯利的&lt;失控&gt;我给很多人推荐.这本书很厚,所以很多人都没有耐心的看完它,我自己也是,可是如果我们面试一个大学生,他告诉我他看完了这本 书,我肯定就录用他--不过他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk0jZM.html" rel="bookmark" class="title">Fortinet再次刷新防火墙性能指标</a>
					<div>
						全球领先的高性能网络安全解决方案供应商Fortinet近日宣布高端企业防火墙阵容中又添新解决方案,将应用于大型企业.数据中心和服务供应商客户.FortiGate 3980E 是世界上首款达到T比特每秒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA34Ob.html" rel="bookmark" class="title">别动我的苹果！多家巨头公司叫板FBI</a>
					<div>
						根据美国媒体报道,在当地时间3月1日,在FBI状告苹果不配合调查解锁用户手机的事件中,数十家与苹果存在竞争关系的企业不约而同的站在了苹果的一方,并指出FBI起诉苹果本身就是一个笑话.当地法院而选择了支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0rD0p.html" rel="bookmark" class="title">使用GROUP BY的时候如何统计记录条数 COUNT&lpar;&ast;&rpar; DISTINCT&lowbar;php技巧</a>
					<div>
						例如这样一个表,我想统计email和passwords都不相同的记录的条数 复制代码 代码如下: CREATE TABLE IF NOT EXISTS `test_users` ( `email_id ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NL6xb.html" rel="bookmark" class="title">排序算法的javascript实现与讲解&lpar;99js手记&rpar;&lowbar;javascript技巧</a>
					<div>
						冒泡排序 冒泡的原理是让最大元素或者最小元素&quot;浮起来&quot; 插入排序,选择排序,快速排序,冒泡排序都是比较排序 思路 依次比较相邻的两个数,将小数放在前面,大数放在后面. step1: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7kOjM.html" rel="bookmark" class="title">寻找Domino高手关于4&period;6的问题，有偿</a>
					<div>
						问题描述 客户那边有个现有的系统,用的Domino4.6,CS架构.因为牵涉很多问题,客户要求不能修改现有系统,不能升级Domino,但是可以外接程序或者其他方式做接口.然后客户要求把现有的流程能在浏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyoB5M.html" rel="bookmark" class="title">院士倪光南：Win 10 不安全 中国必须用自主操作系统</a>
					<div>
						对于发展自主国产操作系统,工程院院士倪光南再次奔走呼号. 据媒体报道,在今天召开的&quot;2017中国通信行业物联网大会&quot;上,倪光南再次重申,Windows 10不列入政府采购项目是例证 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GKoNM.html" rel="bookmark" class="title">韩媒质疑国产网页游戏抄袭《大航海时代》</a>
					<div>
						多玩网讯(编译/弥希)随着网页游戏业的兴起,国产网页游戏的数量也在急剧增长.但与此同时,部分国产网页游戏被质疑盗用众多有名的日本游戏当中的角色或者界面等进行开发制作,特别是日本Square Enix, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
